<template>
  <a-row :gutter="10">

    <a-col :md="leftColMd" :sm="24" style="margin-bottom: 20px">
      <div>
        <a-page-header
          style="background-color: #FFFFFF;"
          title="客户列表 "
          sub-title=""

        >
<!--          <a-descriptions :title="'任务名称:  '+task.taskName" :column="3" :bordered="false">-->
<!--            <a-descriptions-item label="状态"><a-tag :color="task.taskStateColor">{{task.taskStateText}}</a-tag></a-descriptions-item>-->
<!--            <a-descriptions-item label="开始时间">{{task.taskStartTime}}</a-descriptions-item>-->
<!--            <a-descriptions-item label="结束时间">{{task.taskEndTime}}</a-descriptions-item>-->
<!--            &lt;!&ndash;        <a-descriptions-item label="描述"><span v-html="task.description"></span></a-descriptions-item>&ndash;&gt;-->
<!--          </a-descriptions>-->
          <a-divider style="margin: 6px;"/>
        </a-page-header>

        <a-card :bordered="false" style="margin-top: -20px;">
          <a-tabs :active-key="currentTab" default-active-key="all" @change="tabChange">
            <a-tab-pane key="all" :tab="tabAll"></a-tab-pane>
            <a-tab-pane key="noUp" :tab="noUp"></a-tab-pane>
            <a-tab-pane key="undo" :tab="tabUndo"></a-tab-pane>
            <a-tab-pane key="uncheck" :tab="tabUncheck"></a-tab-pane>
            <a-tab-pane key="checked" :tab="tabChecked"></a-tab-pane>
            <a-tab-pane key="passed" :tab="tabPassed"></a-tab-pane>

          </a-tabs>
          <!-- 查询区域 -->
          <div class="table-page-search-wrapper">
            <a-form layout="inline" @keyup.enter.native="searchQuery">
              <a-row :gutter="24">
                <a-col :xl="6" :lg="7" :md="8" :sm="24">
                  <a-form-item label="稽核类型">
                    <j-dict-select-tag placeholder="请选择稽核类型"  v-model="queryParam.type" dictCode="sms_check_task_type" />
                  </a-form-item>
                </a-col>
                <a-col :xl="6" :lg="7" :md="8" :sm="24">
                  <a-form-item label="客户编号">
                    <j-input placeholder="请输入客户编号" v-model="queryParam.customerNo"></j-input>
                  </a-form-item>
                </a-col>
                <a-col :xl="6" :lg="7" :md="8" :sm="24">
                  <a-form-item label="用户编号">
                    <j-input placeholder="请输入用户编号" v-model="queryParam.userNo"></j-input>
                  </a-form-item>
                </a-col>

                <template v-if="toggleSearchStatus">
                  <a-col :xl="6" :lg="7" :md="8" :sm="24">
                    <a-form-item label="员工编号">
                      <j-input placeholder="请输入员工编号" v-model="queryParam.staffNo"></j-input>
                    </a-form-item>
                  </a-col>
                </template>
                <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left;overflow: hidden;" class="table-page-search-submitButtons">
              <a-button type="primary" @click="selectList" icon="search">查询</a-button>
              <a-button type="primary" @click="searchReset" icon="reload" style="margin-left: 8px">重置</a-button>
              <a @click="handleToggleSearch" style="margin-left: 8px">
                {{ toggleSearchStatus ? '收起' : '展开' }}
                <a-icon :type="toggleSearchStatus ? 'up' : 'down'"/>
              </a>
            </span>
                </a-col>
              </a-row>
            </a-form>
          </div>
          <!-- 查询区域-END -->

          <!-- 操作按钮区域 -->
          <div class="table-operator">
            <a-button type="primary" icon="download" @click="handleExportXls('客户列表')">导出</a-button>
<!--            -->
            <!-- 高级查询区域 -->
            <a-dropdown v-if="selectedRowKeys.length > 0">
              <a-menu slot="overlay">
                <a-menu-item key="1" @click="batchDel" v-has="'task:check:list:delete'"><a-icon type="delete"/>删除</a-menu-item>
              </a-menu>
              <a-button style="margin-left: 8px"> 批量操作 <a-icon type="down" /></a-button>
            </a-dropdown>
          </div>

          <!-- table区域-begin -->
          <div>
            <div class="ant-alert ant-alert-info" style="margin-bottom: 16px;">
              <i class="anticon anticon-info-circle ant-alert-icon"></i> 已选择 <a style="font-weight: 600">{{ selectedRowKeys.length }}</a>项
              <a style="margin-left: 24px" @click="onClearSelected">清空</a>
            </div>

            <a-table
              ref="table"
              size="middle"
              :scroll="{x:true}"
              bordered
              rowKey="id"
              :columns="columns"
              :dataSource="dataSource"
              :pagination="ipagination"
              :loading="loading"
              :rowSelection="{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}"
              class="j-table-force-nowrap"
              @change="handleTableChange">
              <template slot="action" slot-scope="text, record">
                <span v-has="'task:check:list:improve'" v-if="record.warningState == 1 || record.warningState == 0 "  >
              <a @click="showImprove(record)">完善上传</a>
              <a-divider type="vertical"/>
            </span>
                <span v-has="'task:check:list:check'" v-if="record.warningState === 2 || record.warningState === 3">
              <a @click="showCheckCheck(record)">稽核</a>
              <a-divider type="vertical" />
            </span>

                <span v-has="'task:check:list:history'" v-if="record.warningState === 4">
              <a @click="showImproveGZ(record)">整改</a>
              <a-divider type="vertical" />
            </span>
                <span v-has="'task:check:list:selectData'" v-if="record.warningState === 5">
              <a @click="selectData(record)">查看数据</a>
              <a-divider type="vertical" />
            </span>

                <span v-has="'task:check:list:selectDataDown'">
              <a @click="getFileUrls(record)">下载资料</a>
              <a-divider type="vertical" />
            </span>
                <span v-has="'task:check:list:notice'" v-if="record.warningState != 2 && record.warningState != 3 && record.warningState != 5">
              <a @click="noticeDeal(record)">催办</a>
              <a-divider type="vertical" />
            </span>
                <a-dropdown>
                  <a class="ant-dropdown-link">更多 <a-icon type="down" /></a>
                  <a-menu slot="overlay">
                    <a-menu-item v-has="'task:check:list:delete'">
                      <a-popconfirm title="确定删除吗?" @confirm="() => handleDelete(record.id)">
                        <a>删除</a>
                      </a-popconfirm>
                    </a-menu-item>
                    <a-menu-item v-has="'task:check:list:clear'">
                      <a-popconfirm title="确定清空吗?" @confirm="() => dataDelete(record.id)">
                        <a>清空</a>
                      </a-popconfirm>
                    </a-menu-item>
                  </a-menu>
                </a-dropdown>
              </template>
              <template v-slot:customerName="text, record">
                <a @click="showCheckDetail(record)">{{text}}</a>
              </template>
              <template v-slot:checkState="status">
                <a-badge :status="status | statusTypeFilter" :text="status | statusFilter"/>
              </template>
              <template v-slot:checkType="text">
                <a-badge  :text="text | checkType "/>
              </template>
              <template v-slot:rowIndex="text,records,index">
                {{ (ipagination.current - 1) * ipagination.pageSize + Number(index)+1 }}
              </template>
            </a-table>
          </div>
          <!-- table区域 end -->
        </a-card>
      </div>
    </a-col>
  </a-row>
</template>

<script>

import { postAction, getAction, httpAction, deleteAction } from '@api/manage'
import '@/assets/less/TableExpand.less'
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import JSZip from 'jszip'
import FileSaver from 'file-saver'
import RoleModal from '@views/system/modules/RoleModal.vue'
import SelectUserModal from '@views/system/modules/SelectUserModal.vue'
import UserModal from '@views/system/modules/UserModal.vue'
import { filterObj } from '@/utils/util'
const statusMap1 = {
  1: {
    color: 'green',
    text: '正常'
  },
  2: {
    color: 'red',
    text: '冻结'
  }
}
export default {
  name: 'TaskCheckList',
  components: { UserModal, SelectUserModal, RoleModal },
  mixins:[JeecgListMixin],
  inject:['closeCurrent'],
  data () {
    let _self = this;
    return {
      statusList:[],
      loading: false,
      visible: false,
      dataSource1: [],
      dataSource2: [],
      currentRoleId: '',
      ipagination2: {
        current: 1,
        pageSize: 10,
        pageSizeOptions: ['10', '20', '30'],
        showTotal: (total, range) => {
          return range[0] + '-' + range[1] + ' 共' + total + '条'
        },
        showQuickJumper: true,
        showSizeChanger: true,
        total: 0
      },
      queryParam2: {},
      rightcolval:0,
      selectedRowKeys1: [],
      selectedRowKeys2: [],
      queryParam:{
      },
      fileInfoList:[
      ],
      dataListSelections:'',
      description: '稽核详情页面',
      currentTab: 'all',
      currentCheckState: null,
      task:{
        id: '',
        taskName: '',
        taskStartTime: '',
        taskEndTime: '',
        description: '',
        taskState: 0,
        taskStateText: '',
        taskStateColor: '',
      },
      tabAll: '全部（0）',
      noUp: '未处理（0）',
      tabUndo: '未完善（0）',
      tabUncheck: '待稽核（0）',
      tabChecked: '待整改（0）',
      tabPassed: '稽核通过（0）',
      count: 0,
      noUpCount:0,
      undoCount: 0,
      uncheckCount: 0,
      checkedCount: 0,
      passedCount: 0,
      orgCode:"",
      columns2: [{
        title: '用户账号',
        align: 'center',
        dataIndex: 'username',
        width: 120
      },
        {
          title: '用户名称',
          align: 'center',
          width: 100,
          dataIndex: 'realname'
        }],

      columns: [
        {
          title: '#',
          dataIndex: '',
          key:'rowIndex',
          width:60,
          align:"center",
          scopedSlots: { customRender: 'rowIndex' }
        },
        {
          title:'稽核类型',
          align:"center",
          sorter: true,
          dataIndex: 'type',
          customRender: function (text) {
            //客户信息所属类型：1:行短稽核 2：物联网业务稽核 3.复开审批 4.中继线稽核
            if (text == '1') {
              return "行短稽核";
            } else if (text == "2") {
              return "物联网业务稽核";
            }  else if (text == "3") {
              return "复开审批";
            }  else if (text == "4") {
              return "中继线稽核";
            }
          }
        },
        {
          title:'客户编号',
          align:"center",
          sorter: true,
          dataIndex: 'customerNo'
        },
        {
          title:'用户编号',
          align:"center",
          dataIndex: 'userNo'
        },
        {
          title:'入网时间',
          align:"center",
          sorter: true,
          dataIndex: 'networkAccessTime'
        },
        {
          title:'员工姓名',
          align:"center",
          dataIndex: 'staffName'
        },
        {
          title:'员工编号',
          align:"center",
          sorter: true,
          dataIndex: 'staffNo'
        },
        {
          title: '员工二级部门',
          align: "center",
          dataIndex: 'staffDeptLevel2Name'
        },
        {
          title: '员工三级部门',
          align: "center",
          dataIndex: 'staffDeptLevel3Name'
        },
        {
          title: '创建时间',
          align: "center",
          dataIndex: 'createTime'
        },
        {
          //0：未处理；1：未完善；2：待稽核；4：待整改；5：稽核通过；）
          title:'预警稽核进度',
          align:"center",
          sorter: true,
          dataIndex: 'warningState',
          scopedSlots: { customRender: 'checkState' }
        },
        {
          title: '操作',
          dataIndex: 'action',
          align:"center",
          scopedSlots: { customRender: 'action' }
        }
      ],
      isorter:{
        column: 'checkState',
        order: 'asc',
      },
      dataSource:[],
      url: {
        queryTask: "/smsCheck/task/queryById",
        lists: "/smsCheck/customerInfo/warningList",
        count: "/smsCheck/customerInfo/WarningCount",
        delete: "/smsCheck/customerInfo/delete",
        edit: "/smsCheck/customerInfo/edit",
        notice: "/smsCheck/customerInfo/notice",
        editCheck: "/smsCheck/customerInfo/edit/check/state",
        dataDelete: "/smsCheck/customerData/clear",
        deleteBatch:"/smsCheck/customerInfo/deleteByIds",
        exportXlsUrl: "smsCheck/customerInfo/exportXls",
      },
      autoSearch: false,
    }
  },
  created() {
    this.task.id = this.$route.query.id;
    this.queryTaskById(this.task.id);
    this.queryParam.taskId = this.task.id;

    this.selectList();
    this.loadTabNumber(this.task.id);
  },
  computed: {
    leftColMd() {
      return this.selectedRowKeys1.length === 0 ? 24 : 15
    },
    rightColMd() {
      return this.selectedRowKeys1.length === 0 ? 0 : 9
    }
  },
  filters: {

    statusTypeFilter(type) {
      const statusTypeMap = {
        '0': 'error',
        '1': 'purple',
        '2': 'warning',
        '3': 'warning',
        '4': 'processing',
        '5': 'success'
      }
      return statusTypeMap[type]
    },
    checkType(text) {
      const statusMap = {
        '0': '未处理',
        '1': '未完善',
        '2': '待稽核',
        '3': '待稽核',
        '4': '待整改',
        '5': '通过'
      }
      return statusMap[text]
    },
    statusFilter(status) {
      const statusMap = {
        '0': '未处理',
        '1': '未完善',
        '2': '待稽核',
        '3': '待稽核',
        '4': '待整改',
        '5': '通过'
      }
      return statusMap[status]
    }
  },
  methods: {
    getQueryParams2() {
      //获取查询条件
      let sqp = {}
      if (this.superQueryParams2) {
        sqp['superQueryParams'] = encodeURI(this.superQueryParams2)
        sqp['superQueryMatchType'] = this.superQueryMatchType2
      }
      var param = Object.assign(sqp, this.queryParam2, this.isorter2, this.filters2)
      param.field = this.getQueryField2()
      param.pageNo = this.ipagination2.current
      param.pageSize = this.ipagination2.pageSize
      return filterObj(param)
    },
    getQueryField2() {
      //TODO 字段权限控制
      var str = 'id,'
      this.columns2.forEach(function(value) {
        str += ',' + value.dataIndex
      })
      return str
    },
    selectList() {
      this.loading = true;
      let params = {
        customerNo: this.queryParam.customerNo,
        userNo: this.queryParam.userNo,
        checkState:this.currentCheckState,
        staffNo: this.queryParam.staffNo,
        type: this.queryParam.type
      }
      getAction(this.url.lists, params).then((res) => {
        if (res.success) {
          if (!res.result){
            this.dataSource = []
          }else {
            this.dataSource = res.result.records ;
          }
          if(res.result && res.result.total) {
            this.ipagination.total = res.result.total;
          }else{
            this.ipagination.total = 0;
          }
          //update-end---author:zhangyafei    Date:20201118  for：适配不分页的数据列表------------
        }else{
          this.$message.warning(res.message)
        }
      }).finally(() => {
        this.loading = false
      })
    },
    transfer(){
      if (this.selectedRowKeys2.length===0){
        this.$message.warn('未选择转派人!')
        return
      }

      if (this.selectedRowKeys.length===0){
        this.$message.warn('未选择需转派的数据!')
        return
      }
      // if ( this.orgCode===''){
      //   this.$message.warn('部门不可为空!')
      //   return
      // }
      let url = '/smsCheck/customerData/transfer';
      let params = {
        userId : this.selectedRowKeys2[0],
        ids:this.selectedRowKeys,
        orgCode: this.orgCode
      }

      postAction(url, params).then(res => {
        if (res.success) {
          this.$message.success('转派成功!')
          this.visible = false;
          this.rightcolval=0;
          this.selectedRowKeys1=[];
          this.searchReset()
          return
        }
      })
    },

    /**文件打包* arrImages:文件list:[{fileUrl:文件url,renameFileName:文件名}]* filename 压缩包名**/
    filesToRar(arrImages, filename) {
      let _this = this;
      let zip = new JSZip();
      let cache = {};
      let promises = [];
      _this.title = '正在加载压缩文件';
     // const loading = this.$loading({lock: true,text: '正在加载压缩文件',spinner: 'el-icon-loading',background: 'rgba(0, 0, 0, 0.7)'});
      for (let item of arrImages) {
        for (let url of item.fileStaticUrl) {

          console.log("item",item)
          // 下载文件, 并存成ArrayBuffer对象
          const promise = this.getImgArrayBuffer(url.fileStaticUrl).then(data => {
            var testZip = zip.folder(item.fileId);
            // 获取文件名
            const file_name = url.fileName
            // 逐个添加文件
            testZip.file(file_name, data, { binary: true })
            //testZip.file(file_name,item.fileId)
            cache[file_name] = data})
            promises.push(promise);
        }
      }
      Promise.all(promises)
        // 生成二进制流
        .then(() => {zip.generateAsync({ type: "blob" })
          .then(content => {_this.title = '正在压缩';
            // 利用file-saver保存文件  自定义文件名
            FileSaver.saveAs(content, filename);
            _this.title = '压缩完成';}
          );
        }).catch(res=>{
        _this.$message.error('文件压缩失败');
      });
    },
    getImgArrayBuffer(url) {
      return new Promise((resolve, reject) => {
        //通过请求获取文件blob格式
        let xmlhttp = new XMLHttpRequest();
        xmlhttp.open("GET", url, true);
        xmlhttp.responseType = "blob";
        xmlhttp.onload = function () {
          if (this.status == 200) {
            resolve(this.response);
          } else {
            reject(this.status);
          }};
        xmlhttp.send();
      });
    },

    // 上传客户资料
    showImprove(record) {
      //行短
      if (record.type===1){
        this.$router.push({path: '/sms/warning/TaskUploadData', query: {id: record.infoId,dueId: record.id}});
      }
    },
    // 整改
    showImproveGZ(record) {
      this.$router.push({path: '/sms/warning/TaskUploadDataCheckZG', query: {id: record.infoId,dueId: record.id}});
    },
// 历史
    selectData(record) {
      this.$router.push({path: '/sms/warning/TaskUploadDataSelect', query: {id: record.infoId,dueId: record.id}});
    },
    // 显示上传页面
    showUpload(record) {
      this.$router.push({ path: '/sms/check/data/upload' ,query:{id:record.id}});
    },
    // 显示上传页面
    handSubmit(record) {
      let that = this;
      let model = {
        id: record.id,
      }
      postAction(this.url.editCheck, model)
        .then((res) => {
          if (res.success) {
            that.$message.success(res.message)
            that.loadData(that.ipagination.current);
          } else {
            that.$message.warning(res.message)
          }
        }).finally(() => {

      })
    },
    dataDelete(id) {
      var that = this;
      deleteAction(that.url.dataDelete, {infoId: id}).then((res) => {
        if (res.success) {
          that.$message.success('附件资料清空完成！');
        } else {
          that.$message.warning('附件资料清空失败！');
        }
      });
    },
    // 显示列表页面
    showCheckCheck(record) {
      this.$router.push({ path: '/sms/warning/TaskUploadDataCheck', query: {id: record.infoId,dueId: record.id}});
    },
    // 显示稽核详情页面
    showCheckDetail(record) {
      this.$router.push({ path: '/sms/warning/TaskUploadDataCheck', query: {id: record.infoId,dueId: record.id}});
    },
    // 显示稽核历史页面
    showCheckLog(record) {
      this.$router.push({ path: '/sms/check/task/check/log',query:{id:record.id}});
    },
    // 构建任务信息
    buildTaskInfo(record) {
      let taskInfo = Object.assign({}, this.task);
      taskInfo.count = this.count;
      taskInfo.undoCount = this.undoCount;
      taskInfo.uncheckCount = this.uncheckCount;
      taskInfo.checkedCount = this.checkedCount;
      taskInfo.passedCount = this.passedCount;
      return  {
        task: this.task,
        info: record
      }
    },
    handleCancel () {
      this.visible = false;
    },
    detail (record) {
      this.model = Object.assign({}, record);
      this.visible = true;
    },
    searchQuery() {
      this.loadData(1);
      this.selectedRowKeys = [];
      this.selectionRows = [];
      this.loadTabNumber();
    },
    searchReset() {
      this.queryParam = {};
      this.queryParam.taskId = this.task.id;
      this.queryParam.checkState_MultiString = this.currentCheckState;
      this.tabChange('all');
      this.loadTabNumber();
    },
    tabChange (key) {
      // 稽核状态（0：未处理；1：未完善；2：待稽核；3：待整改；4：已整改；5：稽核通过；）

      if (key === 'all') {
        this.currentCheckState = null;
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'all';
      } else if (key === 'undo') {
        this.currentCheckState = '1';
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'undo';
      } else if (key === 'uncheck') {
        this.currentCheckState = '2';
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'uncheck';
      } else if (key === 'checked') {
        this.currentCheckState = '4';
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'checked';
      } else if (key === 'passed') {
        this.currentCheckState = '5';
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'passed';
      } else if (key === 'noUp') {
        this.currentCheckState = '0';
        this.queryParam.checkState_MultiString = this.currentCheckState;
        this.currentTab = 'noUp';
      }
      this.selectList();
    },
    loadTabNumber () {
      let url = this.url.count;
      let params = {

      }
      let that = this;
      getAction(url, params).then(res => {
        let { result } = res;
        if (result) {
          that.count = result.count;
          that.undoCount = result.undoCount;
          that.uncheckCount = result.uncheckCount;
          that.checkedCount = result.checkedCount;
          that.passedCount = result.passedCount;
          that.noUpCount = result.noUpCount;
          that.tabAll= '全部（' + result.count + '）';
          that.noUp= '未处理（' + result.noUpCount + '）';
          that.tabUndo= '未完善（' + result.undoCount + '）';
          that.tabUncheck= '待稽核（' + result.uncheckCount + '）';
          that.tabChecked= '待整改（' + result.checkedCount + '）';
          that.tabPassed= '稽核通过（' + result.passedCount + '）';

        }
      }).finally(() => {

      })
    },
    noticeDeal (record) {
      let url = this.url.notice;
      let params = {
        customerName: record.customerName,
        smsNumber: record.smsNumber,
        staffNo: record.staffNo,
        userNo: record.userNo,
        customerNo:record.customerNo,
        taskId:record.taskId,
      }

      let that = this;
      postAction(url, params).then(res => {
        let { result } = res;
        if (res.success) {
          that.$message.info('已通知客户经理，进行材料补充！');
        }
      }).finally(() => {

      })

    },
    queryTaskById (id) {
      let url = this.url.queryTask;
      let params = {
        id: id
      }
      let that = this;
      getAction(url, params).then(res => {
        if (res.success) {
          that.task = res.result;
          that.getTaskState(that.task.taskState);
        }
      }).finally(() => {

      })
    },
    getTaskState(taskState) {
      if (taskState === 0) {
        this.task.taskStateColor = '#fadb14';
        this.task.taskStateText = '未开始';
      } else if (taskState === 1) {
        this.task.taskStateColor = '#1890ff';
        this.task.taskStateText = '稽核中';
      } else if (taskState === 2) {
        this.task.taskStateColor = '#52c41a';
        this.task.taskStateText = '稽核完成';
      }
    }
  }
}
</script>

<style scoped>

</style>